var jUrl = "http://dev.dawul.co.kr/MapAppServer/DWService?callback=?&req=";  //도로링크 api 요청 메인 url
var key = "라이선스키";   //발급받은 라이선스 키

var roadlinkStartMks = new Array();
var roadlinkEndMks = new Array();
var roadlinkLayers = new Array();
var node_name_arr = new Array();

var features = null;
var flag_cnt = 0;
var change_roadName_value = -1;

function linkName_selectList(){
	var link_html = "";
	link_html+="<option value=''>선택</option>";
	for(var i=0; i<test1.length; i++) {
		link_html+="<option value='"+test1[i][0]+"'>"+test1[i][1]+"</option>";
	}
	$("#link_name_list").html(link_html);
}

/*
 * 클릭한 좌표로 요청하기
 */
function roadlink(lat,lng) {
	allClear();
	
	if(lat!=null && lng!=null) {
		var p = Coord_Trans("wgstoutmk", new PT(lng, lat));
		url = jUrl+"{\"header\":{\"format\":\"JSON\",\"key\":\""+key+"\",\"serviceName\":\"EXTENSION_SEARCH\"},\"body\":{\"conditions\":{\"geometry\":{\"spatialOp\":\"NEARBY\",\"circle\":{\"radius\": 20,\"x\":"+p.x+",\"y\":"+p.y+"}}},\"contentName\":\"road_segment\",\"selectFields\":{\"geoType\":\"ORIGIN\"}}}";
		console.log(url)
		
		roadLinkAPI_search(url);
	}
}

/*
 * 링크 아이디 값으로 요청하기
 */
function linkID_Search(){
	allClear();
	
	var link_id = $("#search_link_id").val();
	var url = "";
	url = jUrl+"{\"header\":{\"format\":\"JSON\",\"key\":\""+key+"\",\"serviceName\":\"EXTENSION_SEARCH\"},\"body\":{\"conditions\":{\"field\":[{\"name\":\"link_id\",\"value\":\""+link_id+"\"}]},\"contentName\":\"road_segment\",\"selectFields\":{\"geoType\":\"ORIGIN\"}}}";
	console.log(url)
	
	roadLinkAPI_search(url);
}

/*
 * 링크 이름(링크 아이디 값을 담아서) 요청하기
 */
function linkName_Search(){
	allClear();
	
	var link_name_id = $("#link_name_list").val();
	var url = "";
	url = jUrl+"{\"header\":{\"format\":\"JSON\",\"key\":\""+key+"\",\"serviceName\":\"EXTENSION_SEARCH\"},\"body\":{\"conditions\":{\"field\":[{\"name\":\"link_id\",\"value\":\""+link_name_id+"\"}]},\"contentName\":\"road_segment\",\"selectFields\":{\"geoType\":\"ORIGIN\"}}}";
	console.log(url)
	
	roadLinkAPI_search(url);
}

/*
 * 도로 이름으로 요청하기
 */
function roadName_Search(cnt){
	allClear();
	flag_cnt = cnt;
	
	var road_name = $("#road_name").val();
	var url = "";
	url = jUrl+"{\"header\":{\"format\":\"JSON\",\"key\":\""+key+"\",\"serviceName\":\"EXTENSION_SEARCH\"},\"body\":{\"conditions\":{\"field\":[{\"name\":\"road_name\",\"value\":\""+road_name+"\"}]},\"contentName\":\"road_segment\",\"selectFields\":{\"geoType\":\"ORIGIN\"}}}";
	console.log(url)
	
	roadLinkAPI_search(url);
}

/*
 * API 요청
 */
function roadLinkAPI_search(url){
	$.ajaxSetup({cache:false});
	$.getJSON(url, function(data){
		if(data.body!=null && objectToJSONString(data.body)!="{}") {
			features = data.body.geojson.features;
			
			for(var i=0; i<features.length; i++) {
				var local = features[i];
				var x = local.properties.x_pos;
				var y = local.properties.y_pos;
				var p = Coord_Trans("utmktowgs", new PT(x, y));
				
				node_name_arr.push(local.properties.node_name);
				
				var start;
				var end;
				//UtmK 좌표  ->   Wgs84 좌표 변환
				if (local.geometry.type == "LineString") { // 2배열
					var cntCoord = local.geometry.coordinates.length;
					
					for ( var j = 0; j < cntCoord; j++) {
						var UtmkX = local.geometry.coordinates[j][0];
						var UtmkY = local.geometry.coordinates[j][1];
						var geoWgs = Coord_Trans("utmktowgs", new PT(UtmkX, UtmkY));
						local.geometry.coordinates[j][0] = geoWgs.y;
						local.geometry.coordinates[j][1] = geoWgs.x;
						if(j==0) {
							start = geoWgs.y+","+geoWgs.x;
						}
						if(j==cntCoord-1) {
							end = geoWgs.y+","+geoWgs.x;
							if($("#retType").val()!="") {
								endCoord = geoWgs.y+","+geoWgs.x;
							}
						}
					}
				}else if(local.geometry.type == "MultiLineString" || local.geometry.type == "Polygon") { // 3배열
					var cntCoord = local.geometry.coordinates.length;
					
					for ( var j = 0; j < cntCoord; j++) {
						var cntCoord2 = local.geometry.coordinates[j].length;
						
						
						for ( var k = 0; k < cntCoord2; k++) {
							var UtmkX = local.geometry.coordinates[j][k][0];
							var UtmkY = local.geometry.coordinates[j][k][1];
							var geoWgs = Coord_Trans("utmktowgs", new PT(UtmkX, UtmkY));
							local.geometry.coordinates[j][k][0] = geoWgs.y;
							local.geometry.coordinates[j][k][1] = geoWgs.x;
							if(j==0 && k==0) {
								start = geoWgs.y+","+geoWgs.x;
							}
							if(j==cntCoord-1 && k==cntCoord2-1) {
								end = geoWgs.y+","+geoWgs.x;
								if($("#retType").val()!="") {
									endCoord = geoWgs.y+","+geoWgs.x;
								}
							}
						}
					}
				}
				
				if(flag_cnt == 0){
					var startcoordT = start.split(",");
					roadlinkStartMks.push(new L.Marker(new L.LatLng(startcoordT[0], startcoordT[1]),{icon: new L.Icon({
		   	 	    	iconUrl: "./img/pin_r_b.png",
		   	 	    	iconAnchor: [19,52]
			   			})}).addTo(map));
			   			
		   			var endcoordT = end.split(",");
		   			roadlinkEndMks.push(new L.Marker(new L.LatLng(endcoordT[0], endcoordT[1]),{icon: new L.Icon({
		   	 	    	iconUrl: "./img/pin_b_b.png",
		   	 	    	iconAnchor: [19,52]
			   			})}).addTo(map));
				}
				
	   			roadlinkLayers.push(new L.GeoJSON(
						data.body.geojson.features[i], {
							
							style : function() {
								return {
									weight: 3,
									color : "#0100FF",
									opacity : 1,
									fillColor : "#0100FF",
									fillOpacity : 0
								};						
							}
						}).addTo(map));
	   			
	   			if(roadlinkLayers.length>0) {
	   				map.fitBounds(roadlinkLayers[0].getBounds(),{ padding: [250, 250] });
	   			}
			}
		}
		
		if(flag_cnt == 1){
			roadName_List(node_name_arr);
		}
	});
}

/*
 * 도로 이름 요청 -> 도로 구간 리스트 생성
 */
function roadName_List(node_name_arr){
	var road_html = "";
	road_html +="<option value=''>선택</option>";
	for(var i=0; i<node_name_arr.length; i++) {
		road_html+="<option value='" + i +"'>"+node_name_arr[i]+"</option>";
	}
	$("#road_name_list").html(road_html);
	
	flag_cnt = 0;
}

/*
 * 도로 구간 리스트 선택
 */
function roadName_click(){
	var roadName_value = $("#road_name_list").val();
	
	if(roadName_value != ""){
		if(change_roadName_value != -1){
			map.removeLayer(roadlinkLayers[change_roadName_value]);
			roadlinkLayers[change_roadName_value] = new L.GeoJSON(
					features[change_roadName_value], {
						style : function() {
							return {
								weight: 4,
								color : "#0100FF",
								opacity : 1,
								fillColor : "#0100FF",
								fillOpacity : 1
							};						
						}
			}).addTo(map);
		}
		
		map.removeLayer(roadlinkLayers[roadName_value]);
		roadlinkLayers[roadName_value] = new L.GeoJSON(
				features[roadName_value], {
					style : function() {
						return {
							weight: 4,
							color : "#FF0000",
							opacity : 1,
							fillColor : "#FF0000",
							fillOpacity : 1
						};						
					}
			}).addTo(map);
		map.fitBounds(roadlinkLayers[roadName_value].getBounds(),{ padding: [200, 200] });
		
		change_roadName_value = roadName_value;
	}
}

function allClear() {
	change_roadName_value = -1
	$("#road_name_list").html("");
	
	while (roadlinkStartMks.length > 0) {
		map.removeLayer(roadlinkStartMks[roadlinkStartMks.length - 1]);
		roadlinkStartMks.pop();
	}
	while (roadlinkEndMks.length > 0) {
		map.removeLayer(roadlinkEndMks[roadlinkEndMks.length - 1]);
		roadlinkEndMks.pop();
	}
	while (roadlinkLayers.length > 0) {
		map.removeLayer(roadlinkLayers[roadlinkLayers.length - 1]);
		roadlinkLayers.pop();
	}
	
	while(node_name_arr.length > 0){
		node_name_arr.pop();
	}
}

function objectToJSONString(object) {
	var isArray = (object.join && object.pop && object.push
			&& object.reverse && object.shift && object.slice && object.splice);
	var results = [];

	for ( var i in object) {
		var value = object[i];

		if (typeof value == "object" && value != null)
			results.push((isArray ? "" : "\"" + i.toString() + "\" : ")
					+ objectToJSONString(value));
		else
			results.push((isArray ? "" : "\"" + i.toString() + "\" : ")
					+ (typeof value == "string" ? "\"" + value + "\""
							: value));
	}

	return (isArray ? "[" : "{") + results.join(", ") + (isArray ? "]" : "}");
}
